----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity spi_cs is
	Generic (
			cs_set : integer;
			cs_duration : integer;
			cs_polarity : STD_LOGIC
			);
	
    Port (	clk : in  STD_LOGIC;
			reset : in  STD_LOGIC;
			enable : in  STD_LOGIC;
			position : in INTEGER;
			spi_cs_out : out STD_LOGIC
		   );
end spi_cs;

architecture Behavioral of spi_cs is

begin

CipSelect : process(clk, reset)
begin
	if clk'event and clk = '1' then
		if reset = '1' OR enable = '0' then -- synchronous reset
		spi_cs_out <= NOT cs_polarity;
		elsif position = cs_set then -- sets start point of CS signal
		spi_cs_out <= cs_polarity;
		elsif position = cs_duration + cs_set then -- sets end of CS-Signal
		spi_cs_out <= NOT cs_polarity;		
		end if;
	end if;
end process;

end Behavioral;

